// Version 1.00 07/10/96  First full release.
//         1.01 04/11/96  Shade New and Marker options if there is no active text frame.
//         1.02 22/11/96  'New' menu changed to 'Bookmark'.


int bookmark_handle;
int bookmark_listhandle;
int bookmark_newhandle;


// return the handle of the bookmark at the index specified

int bookmark_fromindex(int index)
{
 string s;

// return(bmname(index, s));

 menudefstring(bookmark_listhandle,index,4,s);
 return(bmfind(s));
}


int bookmark_count(void)
{
 int    i;
 string s;

 i=0;

 while(bmname(i++,s))
 {
  if(!bm_hiddenmark(s))
  {
   return(1);
  }
 }
 return(0);
}


void bookmark_clearmarker(void)
{
 int b;
 int c;
       
 b=bmfind("Marker");
 c=bmfind("Marker2");
 if(b) bmdelete(b);
 if(c) bmdelete(c);
}




// if marker exists, mark from bm to caret else set up bm

void bookmark_marker(void)
{
 int    bm;
 int    cm;
 string s="{BOOKMARK_05}";
 string s2="{BOOKMARK_13}";


 bbc_vdu(7);

 translate(s);
 translate(s2);

 bm=bmfind(s);
 if(bm)
 {
  cm=bmfind(s2);
  if(cm)
  {
   setcarettobm(cm);
   bmdelete(cm);
  }

  setzonetobm(bm);
  bmdelete(bm);
 }
 else
 {
  bm=bmcreate(s);

  if(zoneorder())
  {
   cm=bmcreate(s2);
   setbmtozone(cm,bm);
  }
  else
  {
   setbmtocaret(bm);
  }
 }
}




// deal with 'New' menu entry

void bookmark_new(int code,string & s)
{
 int    bm;
 
 if(code==1)
 {
  if(slen(s))
  {
   bm=bmcreate(s);
   if(bm) setbmtocaret(bm);
  }
 }
}




// deal with 'Bookmarks' menu entries

int bookmark_entry(int entry,int subcode)
{
 switch(entry)
 {
  case 0:               // Goto
         setcarettobm(bookmark_fromindex(subcode));
         break;

  case 1:               // View
         bmview(bookmark_fromindex(subcode));
         break;

  case 2:               // Delete
         bmdelete(bookmark_fromindex(subcode));
         break;

  case 3:				// New
		 gpbox1("{BOOKMARK_07}","{BOOKMARK_08}","","bookmark_new");
		 break;

  case 4:
         bookmark_marker();
         break;

  case 5:
		 bookmark_clearmarker();
		 break;

 }
 return(0);
}


// shade 'Bookmarks' entries if there are no bookmarks

int bookmark_flags(int entry,string & text)
{
 string s;

 switch(entry)
 {
  case 0:
  case 1:
  case 2:
         return(bookmark_count()?0:SHADED);
         break;

  case 3:
         return((activetype(TEXTFRAME)>1)?0:SHADED);
         break;

  case 4:
         if((activetype(TEXTFRAME)>1))
         {
          if(bmfind("Marker")) text="{BOOKMARK_10}";
          else
          {
           if(zoneorder()) text="{BOOKMARK_11}";
           else            text="{BOOKMARK_09}";
          }
         }
         else
		 {
          text="{BOOKMARK_09}";
		 }
         translate(text);
         return((activetype(TEXTFRAME)>1)?0:SHADED);
		 break;

  case 5:
		 return(((activetype(TEXTFRAME)>1) && (bmfind("Marker")))?0:SHADED);
		 break;
 }
}



int bookmark_menu(int open)
{
 return(bookmark_handle);
}



// deal with entries on the bookmark list menu

int bookmark_listentry(int entry,int subcode)
{
 return(entry);
}              


// create a menu listing all the bookmarks that have been created

int bookmark_list(int open)
{
 int    i;
 string s;

 if(bookmark_listhandle) delete_menu(bookmark_listhandle);
 bookmark_listhandle=create_menu("{BOOKMARK_06}");

 i=0;
 while(bmname(i++,s))
 {
  if(!bm_hiddenmark(s))
  {
   addentry_menu(bookmark_listhandle,"bookmark_listentry","","","",s);
  }
 }

 return(bookmark_listhandle);
}




// create 'Bookmarks' menu and add it to 'Applets' menu

void main(void)
{
 script_menu_initialise();

 bookmark_handle=create_menu("{BOOKMARK_00}"); 
 addentry_menu(bookmark_handle,"bookmark_entry","bookmark_flags","bookmark_list","","{BOOKMARK_01}");
 addentry_menu(bookmark_handle,"bookmark_entry","bookmark_flags","bookmark_list","","{BOOKMARK_02}");
 addentry_menu(bookmark_handle,"bookmark_entry","bookmark_flags","bookmark_list","","{BOOKMARK_03}");
 addentry_menu(bookmark_handle,"bookmark_entry","bookmark_flags","","","{BOOKMARK_04}");
 addentry_menu(bookmark_handle,"bookmark_entry","bookmark_flags","","CS_Y","{BOOKMARK_09}");
 addentry_menu(bookmark_handle,"bookmark_entry","bookmark_flags","","","{BOOKMARK_12}");

 script_menu_insert("","","bookmark_menu","","{BOOKMARK_00}");
}
